PROGRAM LCDM;

DEVICE = MEGA644P;

{$I MEGA644P_Register.INC}


CONST


  // Frequenz = 20.000 MHz
  UBRR_VAL : WORD = 32;  // 38400 Baud
//  UBRR_VAL : WORD = 21;  // 57600 Baud
//  UBRR_VAL : WORD = 10;  // 115200 Baud    


VAR

{
A0 - Frame    - A -> L
A1 - Load     - A -> L
A2 - CP       - A -> L
A3 - Disp_off - A -> L
A7 - LED_GR   - A -> L
}
  Frame[PortA,0]    : bit;
  Load[PortA,1]     : bit;
  CP[PortA,2]       : bit;
  Disp_off[PortA,3] : bit;
  LED_GR[PortA, 7]  : bit;

  ZE_Zaehler, SP_Zaehler,
  Ausgabe : Byte;


{$I SYSTEM.INC}




// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
A0 - Frame    - A -> L
A1 - Load     - A -> L
A2 - CP       - A -> L
A3 - Disp_off - A -> L
A7 - LED_GR   - A -> L
}
  //       AEEEAAAA
  DDRA:=  %10001111;

  // PORT B Voreinstellungen
  PORTA:= %00000000;



{
PB0..PB3 = Daten = D0..D3
}
  //       EEEEAAAA
  DDRB:=  %00001111;

  // PORT B Voreinstellungen
  PortB:= %00000000;

end InitPorts;





BEGIN


ASM;

.equ UBRR0 = UBRR0L

ENDASM;


  InitPorts;


  ClearBit(Frame);
  ClearBit(Load);
  ClearBit(CP);
  ClearBit(Disp_off);
  ClearBit(LED_GR);



  SetBit(LED_GR);
  wait_ms(100);
  ClearBit(LED_GR);
  wait_ms(100);

  PortB:= %00000000;


  loop

    // Einschalten des Displays
    SetBit(Disp_off);

    Ausgabe:=%00001100;

    for ZE_Zaehler:=1 to 200 do

      if ZE_Zaehler=1 then
        SetBit(Frame);
      endif;

      PortB:=Ausgabe;

      SetBit(Load);
      nop;
      nop;
      nop;
      ClearBit(Load);


      if Ausgabe=%00001100 then
        Ausgabe:=%00000011;
      else
        Ausgabe:=%00001100;
      endif;


      for SP_Zaehler:=1 to 40 do

        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);
        nop;
        nop;
        nop;
        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);
        nop;
        nop;
        nop;
        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);
        nop;
        nop;
        nop;
        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);

      endfor; // for SP_Zaehler:=1 to 160 do

      ClearBit(CP);
      ClearBit(Frame);

    endfor; // for ZE_Zaehler:=1 to 200 do


  endloop;





END LCDM.
